//
//  MJButton.h
//  iSight_Dance
//
//  Created by David Frampton on 5/10/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>

@class MJImageTexture;
@class ParticleSystem;

@interface NSObject (ButtonEventListenerDelegateMethods)
- (void)buttonEvent:(id)sender;
- (void)buttonOver:(id)sender;
@end


@interface MJButton : NSObject {

    NSRect _rect;
    NSTimeInterval _lastInteraction;
    float _waitTime;
    float _actionCompletionFraction;
    id _eventListener;
    
    MJImageTexture* _onTexture;
    MJImageTexture* _offTexture;
    
    float _sensitivity;
    
    BOOL interactionEnabled;
    float repeatDelay;
    float repeatDelayTimer;
    
    ParticleSystem* particleSystem;
    
}

- (id)initWithRect:(NSRect)rect 
        eventListener:(id)eventListener
        onTexture:(MJImageTexture*)onTexture
        offTexture:(MJImageTexture*)offTexture
        sensitivity:(float)sensitivity;

- (void)draw:(float)dt;
- (void)interaction:(float)fraction;

- (NSRect)rect;

- (void)setInteractionEnabled:(BOOL)interactionEnabled;
- (void)setRepeatDelay:(float)repeatDelay;

@end
