//
//  MJMotionTracker.h
//  iSight_Dance
//
//  Created by David Frampton on 19/9/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>

#define MOTION_TRACKER_SIZE 128
#define VERTICAL_OFFSET_FOR_MOTION_TRACKER_FRACTION 0.5f
#define VERTICAL_OFFSET_FOR_MOTION_TRACKER MOTION_TRACKER_SIZE * VERTICAL_OFFSET_FOR_MOTION_TRACKER_FRACTION

@class WHThreadSafeQueue;

@interface MJHorizontalMotionTracker : NSObject {
    WHThreadSafeQueue* _videoQueue;
    WHThreadSafeQueue* _scrollQueue;
    WHThreadSafeQueue* _motionQueue;
    WHThreadSafeQueue* _buttonRectQueue;
    WHThreadSafeQueue* _buttonEventQueue;
    NSData* _previousData;
}

- (id)initWithVideoQueue:(WHThreadSafeQueue*)videoQueue 
            scrollQueue:(WHThreadSafeQueue*)scrollQueue
            motionQueue:(WHThreadSafeQueue*)motionQueue
            buttonRectQueue:(WHThreadSafeQueue*)buttonRectQueue
            buttonEventQueue:(WHThreadSafeQueue*)buttonEventQueue;
- (void)run;
- (void)runThread;
- (void)_enqueueScrollWithInt:(int)value;

@end
