#import <Cocoa/Cocoa.h>
#import <OpenGL/OpenGL.h>
#import <OpenGL/gl.h>
#import <OpenGL/glu.h>


@interface MJRenderTarget : NSObject {

    NSSize _size;
    GLenum _target;
    GLuint _frameBufferIndex;
    GLuint _depthBufferIndex;
    GLuint _renderTargetTextureID;
    
    GLint _oldViewport[4];
}

- (id) initWithSize:(NSSize)size 
        target:(GLenum)target 
internalFormat:(GLenum)internalFormat 
        format:(GLenum)format 
        type:(GLenum)type 
        requiresDepth:(BOOL)requiresDepth;
        
- (void) setMinFilter:(GLenum)minFilter magFilter:(GLenum)magFilter;

- (void) lock;
- (void) unlock;
- (void) bind;
- (void) unbind;

- (BOOL) checkFrameBufferStatus;

- (GLuint) textureID;

@end
