//
//  MJiTunesImageLoader.h
//  iSight_Dance
//
//  Created by David Frampton on 16/9/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>

@class WHThreadSafeQueue;

@interface MJiTunesImageLoader : NSObject {

    NSArray* _tracks;
    WHThreadSafeQueue* _queue;
    NSOpenGLContext* _context;
    
    BOOL _hasCachePath;
    
    WHThreadSafeQueue* _dataWriteQueue;
    
    WHThreadSafeQueue* _loadQueue;
}

- (id)initWithQueue:(WHThreadSafeQueue*)queue 
    tracks:(NSArray*)tracks 
    context:(NSOpenGLContext*)context
    loadQueue:(WHThreadSafeQueue*)loadQueue;

+ (void)runWithQueue:(WHThreadSafeQueue*)queue 
    tracks:(NSArray*)tracks 
    context:(NSOpenGLContext*)context
    loadQueue:(WHThreadSafeQueue*)loadQueue;

- (void)runThread;
- (void)runDataWriteThread;

- (NSImage*)_loadImageForTrackAtIndex:(unsigned int)index;
- (NSData*)_loadImageDataFromCacheFile:(NSString*)cachePath;
- (NSData*)_loadImageDataFromiTunesForTrackWithID:(NSString*)presistentID;

- (NSOpenGLPixelFormat*)_createPixelFormat;

@end
